<?php

namespace FiloBlu\GuestWishlist\Block\Share;

class Wishlist extends \Magento\Wishlist\Block\Share\Wishlist {

    protected $_helper;

    public function __construct(
    \Magento\Catalog\Block\Product\Context $context, \Magento\Framework\App\Http\Context $httpContext, \Magento\Customer\Api\CustomerRepositoryInterface $customerRepository, \FiloBlu\GuestWishlist\Helper\Data $helper, array $data = []
    ) {
        parent::__construct($context, $httpContext, $customerRepository);
        $this->_helper = $helper;
    }

    /**
     * Retrieve Shared Wishlist Customer instance
     *
     * @return \Magento\Customer\Api\Data\CustomerInterface
     */
    public function getWishlistCustomer() {
        if ($this->_customer === null && $this->_getWishlist()->getCustomerId()) {
            $this->_customer = $this->customerRepository->getById($this->_getWishlist()->getCustomerId());
        }

        return $this->_customer;
    }

    /**
     * Retrieve Page Header
     *
     * @return \Magento\Framework\Phrase
     */
    public function getHeader() {
        if ($this->getWishlistCustomer()) {
            return __("%1's Wish List", $this->escapeHtml($this->getWishlistCustomer()->getFirstname()));
        } else {
            return __("Shared Wish List");
        }
    }

    /**
     * Preparing global layout
     *
     * @return void
     */
    protected function _prepareLayout() {
        if ($this->_helper->getConfig("general/enabled")) {
            $this->setTemplate("Magento_Wishlist::shared.phtml");
            parent::_prepareLayout();
        } else {
            parent::_prepareLayout();
        }
    }

}
